
(define (file:actual-path file)
  (s+ (or
       (assq-ref file 'actual-directory)
       (let* ((directory (assq-ref file 'directory))
              (drop-src (drop-prefix path:src/ directory)))
         (cond ((or (file:src? file) (not drop-src)
                    (string-prefix? path:src/mkmed-data/ directory))
                directory)
               ((not (eq? 'compile (assq-ref file 'stage)))
                (s+ path:src/mkmed-data/ "src/" drop-src))
               ((eq? (assq-ref file 'system) 'build)
                (s+ path:compile/ "build/" drop-src))
               (else
                (s+ path:compile/ "host/" drop-src)))))
      (assq-ref file 'basename)
      (or (assq-ref file 'subpath) "")))

(define (file:src? file)
  (string? (assq-ref file 'rule)))

(define path:src/ "src/")
(define path:src/mkmed-data/ (string-append path:src/ "mkmed-data/"))
(define path:src/mkmed-data/log (string-append path:src/mkmed-data/ "log"))
(define path:compile/      "compile/")
(define path:conf-compile/ "conf-compile/")
(define path:conf/         "conf/")
(define path:package/      "package/")
(define path:compile/move/ (string-append path:compile/ "move/"))
